#netzMadeDifficult Mittel


import numpy as n
import math as math
import random as random
import matplotlib.pyplot as plt


class Netz:
        
    def __init__(self, rad, num, xcor=1, ycor=1):
        
        self.xNetz = []
        self.yNetz = []
        self.Ursprung = [float(xcor), float(ycor)]
        self.Radius = rad
        self.short = rad

        for i in range (num):
            angle = math.pi / num * i * 2
            self.xNetz.append(xcor + (rad * math.cos(angle)))
            self.yNetz.append(ycor + (rad * math.sin(angle)))
            aengl = random.random() * 2 * math.pi
            raeng = random.random() * rad / num
            self.xNetz[i] += raeng * math.cos(aengl)
            self.yNetz[i] += raeng * math.sin(aengl)

    def getAngle(self, xcor, ycor):
        xkor = float(xcor) - self.Ursprung[0]
        ykor = float(ycor) - self.Ursprung[1]
        if (xkor == 0 and ykor == 0):
            print("Error, both pionts are identical")
            return 0
        if(float(xcor) >= self.Ursprung[0]):
            return (math.acos(xkor / pow((xkor*xkor + ykor*ykor), 0.5)))
        else:   
            return (2*math.pi - math.acos(xkor / pow((xkor*xcor + ykor*ykor), 0.5)))

    #einfache Außenbegrenzung
    def makeOutside(self):
        plt.plot([*self.xNetz, self.xNetz[0]], [*self.yNetz, self.yNetz[0]])

    def makeInside(self):
            self.xInside = []
            self.yInside = []
            for i in range (len(self.yNetz)):
                k = (i + 1 ) % len(self.yNetz)

                self.xInside.append((self.xNetz[i] + self.xNetz[i] + self.xNetz[k]) / 3)
                self.yInside.append((self.yNetz[i] + self.yNetz[i] + self.yNetz[k]) / 3)

                self.xInside.append((self.xNetz[i] + self.xNetz[k] + self.xNetz[k]) / 3)
                self.yInside.append((self.yNetz[i] + self.yNetz[k] + self.yNetz[k]) / 3)

            plt.plot([*self.xInside, self.xInside[0]], [*self.yInside, self.yInside[0]])


    #billo-Speichen
    def makeSpeichen(self):
        #Angle ist erstmal überflüssig
        #Angle = [] 
        #for i in range (len(self.xNetz)):
           # Angle.append(self.getAngle(self.xNetz[i], self.yNetz[i]))
        
        for i in range (len(self.xInside)):
            plt.plot([self.Ursprung[0], self.xInside[i]], [self.Ursprung[1], self.yInside[i]])
            if (self.short > pow(pow((self.Ursprung[0] - self.xInside[i]), 2) + pow((self.Ursprung[1] - self.yInside[i]),2),0.5)):
                self.short = pow(pow((self.Ursprung[0] - self.xInside[i]), 2) + pow((self.Ursprung[1] - self.yInside[i]),2),0.5)
    
    def makeSpiral(self):
        self.xSpiral = []
        self.ySpiral = []
        ragne = len(self.xInside) * 32
        for i in range (ragne):
            k = i % len(self.xInside)
            relativePosition = ((i + 20) / (ragne + 40))
            self.xSpiral.append(self.Ursprung[0] + ((self.xInside[k] - self.Ursprung[0]) * relativePosition))
            self.ySpiral.append(self.Ursprung[1] + ((self.yInside[k] - self.Ursprung[1]) * relativePosition))
        plt.plot(self.xSpiral, self.ySpiral)

   
newNet = Netz(20,6)

newNet.makeOutside()
newNet.makeInside()
newNet.makeSpeichen()
newNet.makeSpiral()

plt.show()
                 